﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Private cs As CSBuilder
	Private data As List
	Private ser As B4XSerializator
	Private db As KeyValueStore
	Private senderActivity As Object
	Private clickEventName As String
End Sub

Public Sub Initialize(Component As Object, Dir As String, FileName As String) As clsPCSBuilder
	cs.Initialize
	data.Initialize
	db.Initialize(Dir,FileName)
	senderActivity = Component
	If False Then
		'to avoid obfuscation issues.
		CallSub(Me, "Color")
		CallSub(Me, "Append")
		CallSub(Me, "Pop")
		CallSub(Me, "PopAll")
		CallSub(Me, "Bold")
		CallSub(Me, "Alignment")
		CallSub(Me, "BackgroundColor")
		CallSub(Me, "Clickable")
		CallSub(Me, "EnableClickEvents")
		CallSub(Me, "RelativeSize")
		CallSub(Me, "ScaleX")
		CallSub(Me, "Size")
		CallSub(Me, "Strikethrough")
		CallSub(Me, "Underline")
		CallSub(Me, "VerticalAlign")
		CallSub(Me, "csTypeface")
	End If
	Return Me
End Sub

Public Sub FromBytes(b() As Byte) As clsPCSBuilder
	Dim list As List = ser.ConvertBytesToObject(b)
	For Each o() As Object In list
		If o.Length = 1 Then
			CallSub(Me, o(0))
		Else if o.Length = 2 Then
			CallSub2(Me, o(0), o(1))
		else if o.Length = 3 Then
			CallSub3(Me, o(0), o(1), o(2))
		End If
	Next
	Return Me
End Sub

Public Sub ToBytes As Byte()
	Return ser.ConvertObjectToBytes(data)
End Sub

'Save the PCSBuilder by his Key to the Map (KVS DataBase)
Public Sub Put(Key As String, pcs As clsPCSBuilder)
	Dim b() As Byte = pcs.ToBytes
	db.Put(Key,b)
End Sub

'Load the PCSBuilder by his Key from the Stored Map (KVS DataBase)
Public Sub Get(Key As String) As Object
	Dim b() As Byte = db.Get(Key)
	Return FromBytes(b).Show
End Sub

'Color (Color as Int) as PCSBuilder
'Starts as forground color span.
Public Sub Color (clr As Int) As clsPCSBuilder
	cs.Color(clr)
	data.Add(Array("Color", clr))
	Return Me
End Sub

'Append (Text as CharSequence) As PCSBuilder
'Appends the provided String or CharSequence.
Public Sub Append (Text As Object) As clsPCSBuilder
	cs.Append(Text)
	data.Add(Array("Append", Text))
	Return Me
End Sub

'Bold as PCSBuilder
'Starts a bold span.
Public Sub Bold As clsPCSBuilder
	cs.Bold
	data.Add(Array("Bold"))
	Return Me
End Sub

'Typeface (Typeface as android.graphics.Typeface) As PCSBuilder
'Starts a custom typeface span.
Public Sub csTypeface(myTypeface As Typeface) As clsPCSBuilder
	cs.Typeface(myTypeface)
	data.Add(Array("csTypeface",myTypeface))
	Return Me
End Sub

'Strikethrough As PCSBuilder
'Starts a Strikethrough span.
Public Sub Strikethrough As clsPCSBuilder
	cs.Strikethrough
	data.Add(Array("Strikethrough"))
	Return Me
End Sub

'Underline As PCSBuilder
'Starts an Underline span.
Public Sub Underline As clsPCSBuilder
	cs.Underline
	data.Add(Array("Underline"))
	Return Me
End Sub

'VerticalAlign (Shift as Int) As PCSBuilder
'Starts a vertical alignment span.
Public Sub VerticalAlign(Shift As Int) As clsPCSBuilder
	cs.VerticalAlign(Shift)
	data.Add(Array("VerticalAlign",Shift))
	Return Me
End Sub

'BackgroundColor (Color as Int) as PCSBuilder
'Starts as BackgroundColor color span.
Public Sub BackgroundColor (clr As Int) As clsPCSBuilder
	cs.BackgroundColor(clr)
	data.Add(Array("BackgroundColor", clr))
	Return Me
End Sub

'Alignment (Alignment As android.text.Layou.Alignment) as PCSBuilder
'Start an alignment span.
'Alignment - One of the following strings: ALIGN_NORMAL, ALIGN_OPPOSITE or ALIGN_CENTER.
Public Sub Alignment(Text As String) As clsPCSBuilder
	cs.Alignment(Text)
	data.Add(Array("Alignment",Text))
	Return Me
End Sub

Private Sub myEvent_Click(Tag As Object)
	CallSubDelayed2(senderActivity,clickEventName & "_Click",Tag)
End Sub

'Clickable (EventName as String, Tag as Object) as PCSBuilder
'Starts a clickable span. For the event to be raised you need to call the EnableClickEvents method.
Public Sub Clickable(EventName As String, Tag As Object) As clsPCSBuilder
	cs.Clickable("myEvent",Tag)
	clickEventName = EventName
	data.Add(Array("Clickable",EventName,Tag))
	Return Me
End Sub

'EnableClickEvents (Label as android.widget.TextView)
'This method should be called when using a clickable span.
Public Sub EnableClickEvents(lbl As Label) As clsPCSBuilder
	cs.EnableClickEvents(lbl)
	'data.Add(Array("EnableClickEvents",lbl)) 'this can't be serialized!
	Return Me
End Sub

'RelativeSize (Proportion As Float) as PCSBuilder
'Starts a relative size span. The actual text size will be multiplied with the set Proportion.
Public Sub RelativeSize(csSize As Float) As clsPCSBuilder
	cs.RelativeSize(csSize)
	data.Add(Array("RelativeSize",csSize))
	Return Me
End Sub

'ScaleX (Proportion As Float) as PCSBuilder
'Starts a scale X span. It horizontally scales the text.
Public Sub ScaleX(csSize As Float) As clsPCSBuilder
	cs.ScaleX(csSize)
	data.Add(Array("ScaleX",csSize))
	Return Me
End Sub

'Size (Size as Int) as PCSBuilder
'Starts a text size span. Note that you should not use 'dip' units with the text size dimensions.
Public Sub Size(csSize As Int) As clsPCSBuilder
	cs.Size(csSize)
	data.Add(Array("Size",csSize))
	Return Me
End Sub

'Length as Int (read only)
'Returns the number of characters.
Public Sub GetLength As Int
	Return cs.ToString.Length
End Sub

'Pop as PCSBuilder
'Closes the most recent span. All spans must be closed. You can call PopAll to close all open spans.
Public Sub Pop As clsPCSBuilder
	cs.Pop
	data.Add(Array("Pop"))
	Return Me
End Sub

'PopAll as PCSBuilder
'Closes all open spans.
Public Sub PopAll As clsPCSBuilder
	cs.PopAll
	data.Add(Array("PopAll"))
	Return Me
End Sub

'Show as PCSBuilder
'Call Show to show the PCS on a View
Public Sub Show As Object
	Return cs
End Sub